#include <forms.h>

typedef struct {
    FL_FORM   *mainform;
    FL_OBJECT *quit;
} FD_main;

typedef struct {
    FL_FORM   *auxform;
    FL_OBJECT *auxinput;
} FD_aux;


static FD_main *fd_main;
static FD_aux *fd_aux;

/***************************************
 ***************************************/

void auxform_cb(FL_OBJECT *ob, long data)
{
    //unhide auxform
    if (fl_get_button(ob))
    {
	fl_show_form( fd_aux->auxform, FL_PLACE_POSITION, FL_FULLBORDER, "Aux Form" );
	fl_winfocus( fd_aux->auxform->window );
	fl_set_focus_object( fd_aux->auxform, fd_aux->auxinput );
    }
    else
	fl_hide_form( fd_aux->auxform );
}

FD_main *create_form_main( void )
{
    FL_OBJECT *obj;
    FD_main *fdui = fl_malloc( sizeof *fdui );

    fdui->mainform = fl_bgn_form( FL_NO_BOX, 280, 180 );

    fl_add_box( FL_FLAT_BOX, 0, 0, 280, 180, "" );

    int ix = 20;
    int iy = 20;
    int iw = 240;
    int ih = 40;

    obj = fl_add_text( FL_NORMAL_TEXT, ix, iy, iw, ih, "Main Form" );
    fl_set_object_lalign( obj, FL_ALIGN_CENTER );
    fl_set_object_boxtype( obj, FL_DOWN_BOX );
    fl_set_object_lsize( obj, FL_HUGE_SIZE );
    fl_set_object_color( obj, FL_WHITE, FL_WHITE );

    iy += ih;
    obj = fl_add_input(FL_NORMAL_INPUT, ix, iy, iw, ih, "");
    fl_set_object_lalign(obj, FL_ALIGN_RIGHT);
    fl_set_object_lsize( obj, FL_HUGE_SIZE );
    fl_set_input_return(obj, FL_RETURN_CHANGED);

    iy += ih;
    obj = fl_add_lightbutton(FL_PUSH_BUTTON, ix, iy, iw, ih, "Show Aux Form");
    fl_set_object_resize(obj, FL_RESIZE_NONE);
    fl_set_object_callback(obj, auxform_cb, 0);
    fl_set_button_mouse_buttons(obj, 1 );

    iy += ih;
    fdui->quit = obj = fl_add_button( FL_NORMAL_BUTTON, ix, iy, iw, ih, "Exit" );
    fl_set_object_color( obj, FL_RED, FL_RED );
    fl_set_object_lcolor( obj, FL_WHITE );
    fl_set_object_lsize( obj, FL_HUGE_SIZE );

    fl_end_form( );

    return fdui->mainform->fdui = fdui;
}


FD_aux *create_form_aux( void )
{
    FL_OBJECT *obj;
    FD_aux *fdui = fl_malloc( sizeof *fdui );

    fdui->auxform = fl_bgn_form( FL_NO_BOX, 280, 180 );

    fl_add_box( FL_FLAT_BOX, 0, 0, 280, 180, "" );

    int ix = 20;
    int iy = 20;
    int iw = 240;
    int ih = 40;

    obj = fl_add_text( FL_NORMAL_TEXT, ix, iy, iw, ih, "Aux Form" );
    fl_set_object_lalign( obj, FL_ALIGN_CENTER );
    fl_set_object_boxtype( obj, FL_DOWN_BOX );
    fl_set_object_lsize( obj, FL_HUGE_SIZE );
    fl_set_object_color( obj, FL_WHITE, FL_WHITE );

    iy += ih;
    fdui->auxinput = obj = fl_add_input(FL_NORMAL_INPUT, ix, iy, iw, ih, "");
    fl_set_object_lalign(obj, FL_ALIGN_RIGHT);
    fl_set_object_lsize( obj, FL_HUGE_SIZE );
    fl_set_input_return(obj, FL_RETURN_CHANGED);

    fl_end_form( );

    return fdui->auxform->fdui = fdui;
}


/***************************************
 ***************************************/

int main( int argc, char *argv[] )
{
    int ix, iy, iw, ih;

    fl_initialize( &argc, argv, 0, 0, 0 );
    fd_main = create_form_main( );
    fd_aux = create_form_aux( );

    fl_show_form( fd_main->mainform, FL_PLACE_CENTERFREE, FL_FULLBORDER, "Main Form" );

    fl_get_wingeometry( fd_main->mainform->window, &ix, &iy, &iw, &ih );
    fl_set_form_position( fd_aux->auxform, ix + iw + 20, iy);

    while ( fl_do_forms( ) != fd_main->quit )
        /* empty */ ;

    fl_finish( );
    fl_free( fd_main );

    return 0;
}
